<?php
//Account iterator

require_once('api.php');
require_once('domain.php');
require_once('account.php');

class AccountIterator
{
	public function onDomainStart(&$domain)
	{
		
	}
	
	public function onDomainEnd(&$domain)
	{
		
	}
	
	public function onAccountStart(&$domain,&$account)
	{
		
	}
	
	public function onAccount(&$domain,&$account)
	{
		
	}
	
	public function onAccountEnd(&$domain,&$account)
	{
		
	}

	public function exec()
	{
		$api = IcewarpAPI::instance('Script to fix u_name from primary u_alias');
		$account = new IcewarpAccount();
		$domain = new IcewarpDomain();
		$domainCount = $api->GetDomainCount();
		for ($i = 0; $i < $domainCount; $i++) {
			$domainName = $api->GetDomain($i);
			//Skip unwanted domains
			if ($this->filterDomain && $this->filterDomain != $domainName) {
				continue;
			}
			$this->message("<hr><h2>Processing domain '$domainName'</h2>");
			$domain->Open($domainName);
			$this->onDomainStart($domain);
			if ($this->filterAccount) {
				$filter = " u_alias like '" . $this->filterAccount . "'";
			} else {
				$filter = "";
			}
			if (!$account->FindInitQuery($domainName, $filter)) {
				$this->error("API Problem : Icewarp account object retrieval");
			}
			while ($account->FindNext()) {
				$email = $account->EmailAddress;
				$this->message("<h3>processing account '$email'</h3>");
				$this->onAccountStart($domain,$account);
				// only user accounts will be processed
				
				$this->onAccount($domain, $account);
				$this->onAccountEnd($domain,$account);
			}
			$account->FindDone();
		}
	}
	
	protected function message($msg)
	{
		echo $msg."<br/>";
	}
}
?>
